package member;


import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;


public class MemberDAO {





	 private Connection conn;
	 private PreparedStatement ps;
	 private ResultSet rs;
	 private static MemberDAO instance;


	 public static MemberDAO getInstance() {
		 if(instance==null)
			 instance=new MemberDAO();
			 return instance;
	 }




	public void join(MemberDTO dto) {
		String sql="INSERT INTO MEMBER (NAME, HURIGANA, ID, PASSWORD, GENDER, EMAIL, ZIP, ADDR, HOBBY, ID_NUM) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, (select count(id_num)+1 from member))";
		try {

			ps=conn.prepareStatement(sql);
			System.out.println(dto.getName());
			System.out.println(dto.getId());
			System.out.println(dto.getPassword());




			ps.setString(1, dto.getName());
			ps.setString(2, dto.getHurigana());
			ps.setString(3, dto.getId());
			ps.setString(4, dto.getPassword());
			ps.setString(6, dto.getEmail());
			ps.setString(5, dto.getGender());
			ps.setString(7, dto.getZip());
			ps.setString(8, dto.getAddr());
			ps.setString(9, hobby(dto.getHobby()));

			ps.executeUpdate();

		}catch(SQLException e) {

		}finally {
			disconnect();

		}


	}

	public String hobby(String[] str) {
		String hobby="";


		for(String s : str) {
			hobby+= s + ",";
		}

		hobby= hobby.substring(0, hobby.length() - 1);



		return hobby;
	}

	public MemberDTO login(String id, String pwd) throws SecurityException, IOException {
		MemberDTO dto = null;
		String sql = "select * from member "
				+ "where id = ? and password = ?";
		try {
			ps = conn.prepareStatement(sql);
			ps.setString(1, id);
			ps.setString(2, pwd);
			rs = ps.executeQuery();
			String addres="C:\\Users\\user\\Documents\\PSC\\log\\HelloJava.log";

			// Loggerクラスのインスタンスを生成
	        Logger logger = Logger.getLogger(MemberDAO.class.getName());
	        // Handlerを生成しloggerに登録
	        FileHandler fHandler = new FileHandler(addres, true);
	        fHandler.setFormatter(new SimpleFormatter());
	        logger.addHandler(fHandler);

	        // ログレベルの設定
	        logger.setLevel(Level.INFO);

	        logger.info("情報ログテスト");
	        logger.warning("警告ログテスト");
	        logger.severe("エラーログテスト");
	        logger.info("ユーザID："+id);
	        logger.info("パスワード："+pwd);

			if( rs.next() ) {
				dto = new MemberDTO();

				dto.setId( rs.getString("id") );
				dto.setPassword( rs.getString("pwd") );

			}
		} catch (SQLException e) {
		} finally {
			disconnect();
		}
		return dto;
	}


	public MemberDTO getUserInfo(String id) {
		Connection conn=null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		MemberDTO member = null;

		try {
		    StringBuffer query = new StringBuffer();
			query.append("select * from member where id=?");
			conn=DBConnection.getConnection();
				pstmt=conn.prepareStatement(query.toString());
				pstmt.setString(1, id);
				rs=pstmt.executeQuery();

				if(rs.next()) {
					member = new MemberDTO();
					member.setName(rs.getString("name"));
					member.setHurigana(rs.getString("hurigana"));
					member.setId(rs.getString("id"));
					member.setEmail(rs.getString("email"));
					member.setGender(rs.getString("gender"));
					member.setZip(rs.getString("zip"));
					member.setAddr(rs.getString("addr"));
					member.setShobby(rs.getString("hobby"));



				}
				return member;
		} catch (Exception sqle) {
	             throw new RuntimeException(sqle.getMessage());
	         } finally {
	             try{
	                 if ( pstmt != null ){ pstmt.close(); pstmt=null; }
	                 if ( conn != null ){ conn.close(); conn=null;    }
	             }catch(Exception e){
	                 throw new RuntimeException(e.getMessage());
	             }
	         }


	    }







	public boolean duplicateIdCheck(String id) {
		Connection conn=null;
		PreparedStatement pstm=null;
		ResultSet rs = null;
		boolean x = false;
		try {

			StringBuffer query=new StringBuffer();
			query.append("SELECT ID FROM MEMBER WHERE ID=?");

			conn=DBConnection.getConnection();
			pstm=conn.prepareStatement(query.toString());
			pstm.setString(1, id);
			rs=pstm.executeQuery();
			if(rs.next())
				{
				x=true;

				}
			return x;

		} catch(Exception sqle) {
			throw new RuntimeException(sqle.getMessage());
		}finally {
			try {
				if(pstm !=null) {
					pstm.close();
					pstm=null;
				}
				if(conn!=null) {
					conn.close();
					conn=null;
				}
			}catch(Exception e) {
				throw new RuntimeException(e.getMessage());
			}
		}
	}






	private void disconnect() {
		if(rs!=null) {
			try {
				rs.close();
			}catch(Exception e){}
		}
		if(ps!=null) {
			try {
				rs.close();
			}catch(Exception e){}
		}
		if(conn!=null) {
			try {
				rs.close();
			}catch(Exception e){}
		}
	}

	public MemberDAO() {
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			conn = DriverManager.getConnection(
					"jdbc:oracle:thin:@localhost:1521:orcl", "parkseungchur", "1234");
		}catch(Exception e){

		}
	}

}
