package com.example.dg;

import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.example.dg.DB.TestOpenHelper;


public class MainActivity extends AppCompatActivity {

    int version = 1;
    TestOpenHelper helper;
    SQLiteDatabase database;

    EditText etEmail;
    EditText etPassword;

    Button btnRegist;
    Button btnLogin;

    String sql;
    Cursor cursor;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        etEmail = (EditText)findViewById(R.id.etEmail);
        etPassword = (EditText)findViewById(R.id.etPassword);

        btnRegist = (Button)findViewById(R.id.btnRegist);
        btnLogin = (Button)findViewById(R.id.btnLogin);

        helper = new TestOpenHelper(MainActivity.this, TestOpenHelper.TABLE_NAME, null, version);
        database = helper.getWritableDatabase();

        btnLogin.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View v){
                String email = etEmail.getText().toString();
                String pwd = etPassword.getText().toString();

                if(email.length() == 0 || pwd.length() == 0){
                    Toast toast = Toast.makeText(MainActivity.this, "Emailとパスワードを必須です。",Toast.LENGTH_SHORT);
                    toast.show();
                    return;
                }

                sql = "SELECT email FROM "+helper.TABLE_NAME+" WHERE email = '"+email+"'";
                cursor = database.rawQuery(sql, null);

                if(cursor.getCount() != 1){
                    Toast toast = Toast.makeText(MainActivity.this, "存在しないEmailです。",Toast.LENGTH_SHORT);
                    toast.show();
                    return;
                }

                sql = "SELECT pwd FROM "+helper.TABLE_NAME+" WHERE email = '"+email+ "'";
                cursor = database.rawQuery(sql, null);

                cursor.moveToNext();
                if(!pwd.equals(cursor.getString(0))){
                    Toast toast = Toast.makeText(MainActivity.this,"パスワードが間違います。", Toast.LENGTH_SHORT);
                    toast.show();
                }else{
                    Toast toast = Toast.makeText(MainActivity.this,"ログイン成功",Toast.LENGTH_SHORT);
                    toast.show();
                    Intent intent = new Intent(getApplicationContext(),LogInfo.class);
                    startActivity(intent);
                    finish();
                }
                cursor.close();
            }
        });

        btnRegist.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View v){
                Intent intent = new Intent(getApplicationContext(),RegistActivity.class);
                intent.setFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
                startActivityForResult(intent, 1000);
            }
        });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data){
        super.onActivityResult(requestCode, resultCode, data);

        if(requestCode == 1000 && resultCode == RESULT_OK){
            etEmail.setText(data.getStringExtra("email"));
        }
    }
}
