package com.example.dg;

import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.example.dg.DB.TestOpenHelper;

public class RegistActivity extends AppCompatActivity {

    int version = 1;
    TestOpenHelper helper;
    SQLiteDatabase database;

    EditText etEmail;
    EditText etName;
    EditText etPassword;
    EditText etPasswordConfirm;

    Button btnDone;
    Button btnCancel;

    String sql;
    Cursor cursor;

    @Override
    protected void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_registactivity);

        etEmail = (EditText)findViewById(R.id.etEmail);
        etName = (EditText)findViewById(R.id.etName);
        etPassword = (EditText)findViewById(R.id.etPassword);
        etPasswordConfirm = (EditText)findViewById(R.id.etPasswordConfirm);

        btnDone = (Button)findViewById(R.id.btnDone);
        btnCancel = (Button)findViewById(R.id.btnCancel);

        helper = new TestOpenHelper(RegistActivity.this, TestOpenHelper.TABLE_NAME, null, version);
        database = helper.getWritableDatabase();

        etPasswordConfirm.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence charS, int start, int count, int after) {
                String password = etPassword.getText().toString();
                String confirm = etPasswordConfirm.getText().toString();

                if(password.equals(confirm)){
                    etPassword.setBackgroundColor(Color.GREEN);
                    etPasswordConfirm.setBackgroundColor(Color.GREEN);
                }else{
                    etPassword.setBackgroundColor(Color.RED);
                    etPasswordConfirm.setBackgroundColor(Color.RED);
                }
            }

            @Override
            public void afterTextChanged(Editable editable) {

            }
        });

        btnDone.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View v){

                String email = etEmail.getText().toString();
                String name = etName.getText().toString();
                String pwd = etPassword.getText().toString();

                if(etEmail.getText().toString().length() == 0){
                    Toast.makeText(RegistActivity.this, "Emailを入力してください。", Toast.LENGTH_SHORT).show();
                    etEmail.requestFocus();
                    return;
                }

                if(etPassword.getText().toString().length() == 0){
                    Toast.makeText(RegistActivity.this, "パスワードを入力してください。", Toast.LENGTH_SHORT).show();
                    etPassword.requestFocus();
                    return;
                }

                if(etPasswordConfirm.getText().toString().length() == 0){
                    Toast.makeText(RegistActivity.this,"パスワード確認を入力してください。",Toast.LENGTH_SHORT).show();
                    etPasswordConfirm.requestFocus();
                    return;
                }

                if(!etPassword.getText().toString().equals(etPasswordConfirm.getText().toString())){
                    Toast.makeText(RegistActivity.this,"パスワードが間違います。", Toast.LENGTH_SHORT).show();
                    etPassword.setText("");
                    etPasswordConfirm.setText("");
                    etPassword.requestFocus();
                    return;
                }

                sql = "SELECT email FROM "+helper.TABLE_NAME+" WHERE email = '"+email+"'";
                cursor = database.rawQuery(sql, null);

                if(cursor.getCount() != 0){
                    Toast toast = Toast.makeText(RegistActivity.this,"存在したEmailです。",Toast.LENGTH_SHORT);
                    toast.show();
                }else{
                    helper.insertUser(database, email, pwd);
                    Toast toast = Toast.makeText(RegistActivity.this,"登録完了!ログインしてください。",Toast.LENGTH_SHORT);
                    toast.show();
                    Intent intent = new Intent(getApplicationContext(),RegistActivity.class);
                    startActivity(intent);
                    finish();
                }

                Intent result = new Intent();
                result.putExtra("email",etEmail.getText().toString());

                setResult(RESULT_OK, result);
                finish();
            }
        });

        btnCancel.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View v){
                finish();
            }
        });
    }
}
